package me.hammerle.supersnuvi.util;

import me.hammerle.supersnuvi.entity.Entity;

public enum Face 
{
    LEFT(Entity.STEP, 0),
    RIGHT(-Entity.STEP, 0),
    UP(0, -Entity.STEP),
    DOWN(0, Entity.STEP);
    
    private float offsetX;
    private float offsetY;
    
    Face(float offsetX, float offsetY)
    {
        this.offsetX = offsetX;
        this.offsetY = offsetY;
    }
    
    public Face getOpposite()
    {
        switch(this)
        {
            case LEFT: return RIGHT;
            case RIGHT: return LEFT;
            case UP: return DOWN;
            case DOWN: return UP;
        }
        return UP;
    }
    
    public float getCollisionOffsetX()
    {
        return offsetX;
    }
    
    public float getCollisionOffsetY()
    {
        return offsetY;
    }
}
